set terminal postscript eps enhanced color font 'Arial,16'
set output 'canneal-4threads.eps'

set title "Canneal - 4 threads" 
set grid

set xlabel "Parallelism"
set ylabel "Criticality (in seconds)"

set key outside right center

set xtics ('4' -4, '3' -3, '2' -2, '1' -1, '0' 0, '1' 1, '2' 2, '3' 3, '4' 4)

set xrange [-4:4]
set yrange [0:90]

set object 1 rect from -3.903,0 to 3.903,11.262148146 fc rgb "blue"
set object 2 rect from -3.855,11.262148146 to 3.855,22.826445807 fc rgb "green"
set object 3 rect from -3.847,22.826445807 to 3.847,34.425498678 fc rgb "red"
set object 4 rect from -3.826,34.425498678 to 3.826,46.091770181 fc rgb "yellow"
set object 5 rect from -1,46.091770181 to 1,87.470487121 fc rgb "cyan"

set style fill solid 1.0 border -1

plot -1 with boxes title "Thread 1" lc rgb "cyan", -1 with boxes title "Thread 2" lc rgb "blue", -1 with boxes title "Thread 3" lc rgb "yellow", -1 with boxes title "Thread 4" lc rgb "red", -1 with boxes title "Thread 5" lc rgb "green"
