/********************************************************************

 Environment variables:

 PARMACS_PINTHREADS        1 to pin threads to processors (thread id = processor id)
                           comma-separated list to pin threads to specific processors

 ********************************************************************/

#include "hooks_base.h"
/*
#define _GNU_SOURCE
#include <sched.h>
#include <pthread.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/syscall.h>

#define MAX_THREADS 1024
*/

// JBS NOTE  UNHALTED_CORE_CYCLES':                       0x003c

extern __thread int PThreadId;
/*
typedef struct {
  pthread_t thread;
  void *(*func)(void *);
  void *arg;
} PThreadTable_t;
*/
PThreadTable_t PThreadTable[MAX_THREADS];
int PThreadIndex = 0;
int PThreadNCPUS = 0;
int * PThreadCpumap = NULL;
int PThreadAppRegisterIndex = 0; //2; //JBS CHANGE BACK to ZERO later!  TESTING... //jbs added 
int PThreadAppSpecialRegisterIndex = 0; //jbs added - only used with speical specifier in call from Jikes
static int startThreadMonitorIndex = 0;

__thread int PThreadId;

const int PIN_THREADS = 3;  //if > 0 pin threads.  Pin threads to cores 0-3 except when receive call from Java for a particular thread, put it on core 7
  //1 = pin all threads on cores 0-3;  2 = pin compilation thread to core 7, others to 0-3   //3 = put all VM threads to MAGIC core, rest to 0-6
//4 = alternate between 1st socket and 2nd socket
static int MAGIC_THREAD_ID_TO_SEPARATE = 0; //JBS NOTE - set in constructor below!  Cannot be constant PThreadNCPUS - 1;  //9;
const int IGNORE_SPECIFIER = 1;  //whether to treat a call down from Jikes to pin a thread as a "special" one to pin differently than the others.
static int UPPER_BOUND_APP_THREAD = 0;
const int DEBUG_VERBOSE = 0;

const int ENABLE_PERF_CNTRS  = 1;  //if enabled (=1), PIN_THREADS should be 3, and the following enviro variables should be set
const int numAppThreads = 4;
const int numGCThreads = 4;
const int numInitialVMThreads = 10;
static int firstAppThreadIndex = 0; //10 + numGCThreads;
static int yetReceivedFirstZeroSpecifier = 0;
/* 
export PARMACS_PERFCTRS=003c
export PARMACS_PERFCTRS_FILE=/home/jbsartor/running/perfCounter.out

 */

/* MAPPING:
   PThreadNCPUS = map to cores 0-3
   PThreadNCPUS + 1 = map to cores 4-7
   PThreadNCPUS + 2 = map to all cores
*/

void parmacs_setup_cpumap() {
  int i;

  PThreadNCPUS = sysconf(_SC_NPROCESSORS_CONF);
  PThreadCpumap = (int*) malloc(PThreadNCPUS * sizeof(int));
  char * cpumap = getenv("PARMACS_PINTHREADS");
  if (! cpumap || strchr(cpumap, ',') == NULL) {
    /* No explicit cpumap provided, use logical processor numbers */
    for(i = 0; i < PThreadNCPUS; ++i)
      PThreadCpumap[i] = i;
  } else {
    char * cpu = strtok(cpumap, ",");
    for(i = 0; i < PThreadNCPUS; ++i) {
      if (cpu == NULL) {
        PThreadNCPUS = i;
        break;
      }
      PThreadCpumap[i] = atoi(cpu);
      cpu = strtok(NULL, ",");
    }
  }
  //jbs added
  MAGIC_THREAD_ID_TO_SEPARATE = PThreadNCPUS; //put on cores 0-3 //PThreadNCPUS - 1;
  UPPER_BOUND_APP_THREAD = PThreadNCPUS / 2; //PThreadNCPUS - 1;
  PThreadAppSpecialRegisterIndex =  UPPER_BOUND_APP_THREAD;
  firstAppThreadIndex = numInitialVMThreads + 1 + numGCThreads; //have to go 1 above number because of calculations below.  Normally there are 10 base JVM threads, and a number of GC threads

  if (PIN_THREADS > 0 && PIN_THREADS < 3) {  
    for(i = 0; i < MAX_THREADS; i++) {
      PThreadTable[i].mappedCore = PThreadNCPUS;  //if pinning threads, set up that all will go to cores 0-3
    }
  } else if (PIN_THREADS ==3 || PIN_THREADS ==4 || PIN_THREADS == 5) {
    for(i = 0; i < MAX_THREADS; i++) {
      PThreadTable[i].mappedCore = MAGIC_THREAD_ID_TO_SEPARATE; //PThreadNCPUS - 1;  //if pinning threads, set up that all that aren't specified will go on core 7
    }
  }
  if (ENABLE_PERF_CNTRS) 
    HookPerfstat();
  
}

void non_parmacs_setThreadID(int threadNum, int specifier) {
    /*if ((PThreadIndex + 1) != threadNum) {
      printf("JBS ERROR!  Pthread index and thread num in non_parmacs_setThreadID don't match: %d and %d\n", PThreadIndex, threadNum);
      }*/
  //  if (ENABLE_PERF_CNTRS && PIN_THREADS ==3 && /*firstAppThreadIndex == 0 && */ specifier == 0 && yetReceivedFirstZeroSpecifier == 0) {
  //   firstAppThreadIndex = threadNum; //save first app - ignore if specifier = 1 (the special first string to pin - should be collector)
  // }
  if (specifier== 0 && yetReceivedFirstZeroSpecifier == 0) {
    yetReceivedFirstZeroSpecifier = 1;
  }

    if (PIN_THREADS > 0 && PIN_THREADS < 3) {
      PThreadTable[threadNum].mappedCore = PThreadNCPUS - 1;
    }
    if (PIN_THREADS == 3) {  //should get threads whose names start with "Thread"
      if ( IGNORE_SPECIFIER || specifier == 0) {
	PThreadTable[threadNum].mappedCore = (PThreadAppRegisterIndex % (UPPER_BOUND_APP_THREAD));
	if (MAGIC_THREAD_ID_TO_SEPARATE == 0) {
	  PThreadTable[threadNum].mappedCore += 1;  //instead of 0-6, it'll be 1-7
	}
	PThreadAppRegisterIndex++;
      } else if (!IGNORE_SPECIFIER && specifier == 1) {
	if (PThreadAppSpecialRegisterIndex == PThreadNCPUS) {
	  PThreadAppSpecialRegisterIndex = UPPER_BOUND_APP_THREAD;
	}
	PThreadTable[threadNum].mappedCore = (PThreadAppSpecialRegisterIndex % PThreadNCPUS);  //pin this one separately, special
	PThreadAppSpecialRegisterIndex++;
      }
     
    } else if (PIN_THREADS == 4) {  //switch from cores 0 and 1 to cores 4 and 5 - back and forth
      int specialModUpperBound; //determined by numGC or numApp Threads, which should be 4 or 8!!
      if (specifier == 1) {
	specialModUpperBound = numGCThreads /2;  //if < this, on first socket, >= this, on 2nd socket.
      } else {
	specialModUpperBound = numAppThreads /2;
      }
      int newPinIndex = PThreadAppRegisterIndex % (specialModUpperBound * 2);  //should be 0-7 max, and therefore will work as core #
      if (newPinIndex < specialModUpperBound) {
	PThreadTable[threadNum].mappedCore = newPinIndex;
      } else {
	PThreadTable[threadNum].mappedCore = UPPER_BOUND_APP_THREAD - specialModUpperBound + newPinIndex;
      }
      PThreadAppRegisterIndex++; 
      /*if (PThreadAppRegisterIndex == 0 || PThreadAppRegisterIndex == 1) {
	PThreadTable[threadNum].mappedCore = (PThreadAppRegisterIndex);
      } else if (PThreadAppRegisterIndex == 2 || PThreadAppRegisterIndex == 3) {
	PThreadTable[threadNum].mappedCore = UPPER_BOUND_APP_THREAD - 2 + PThreadAppRegisterIndex;
      }
      PThreadAppRegisterIndex++; 
      PThreadAppRegisterIndex = PThreadAppRegisterIndex % UPPER_BOUND_APP_THREAD;
      */
    } else if (PIN_THREADS == 5) {  //also CHECK RVMTHREAD.JAVA WITH THIS OPTION!
      if (specifier == 1) {  //for experiment "5", we receive a specifier for first *3* strings, not just 1
	PThreadTable[threadNum].mappedCore = PThreadAppSpecialRegisterIndex; //will only be on 2nd socket
	PThreadAppSpecialRegisterIndex++;
	if (PThreadAppSpecialRegisterIndex == PThreadNCPUS) {
	  PThreadAppSpecialRegisterIndex = UPPER_BOUND_APP_THREAD;
	}
      } else {
	PThreadTable[threadNum].mappedCore = (PThreadAppRegisterIndex % (UPPER_BOUND_APP_THREAD));
	PThreadAppRegisterIndex++;
      }
    }

    if (DEBUG_VERBOSE) 
      printf(" JBS in non_parmacs_setThreadID with thread %d and setting it to core %d \n", threadNum, PThreadTable[threadNum].mappedCore);
   
  }

void parmacs_pin_thread(int threadnum) {
  int cpunum = PThreadCpumap[threadnum % PThreadNCPUS];
  /*if (threadnum >= PThreadNCPUS) {
    printf("[HOOKS] Only %u CPUs, wrapping around thread %u to CPU %u\n", PThreadNCPUS, threadnum, cpunum); fflush(NULL);
    }*/
  if (PIN_THREADS) { // && threadnum > 0) { //PThreadTable not set up for 0th thread!
    cpunum = PThreadTable[threadnum].mappedCore;
    if (cpunum != PThreadNCPUS && DEBUG_VERBOSE) {
      printf("[HOOKS] Pinning thread %d to abnormal core %d\n", threadnum, cpunum);
    } 
  }
   if (DEBUG_VERBOSE)
    printf("JBS in parmacs_pin_thread with threadNum %d and pinning to %d \n", threadnum, cpunum);
  
  cpu_set_t cpu_set;
  int i;
  CPU_ZERO(&cpu_set);
  if (cpunum == PThreadNCPUS) {
    for (i = 0; i < (PThreadNCPUS / 2); i++) {
      CPU_SET(i, &cpu_set);
    }
  } else if (cpunum == (PThreadNCPUS + 1)) {
    for (i = (PThreadNCPUS / 2); i < PThreadNCPUS; i++) {
      CPU_SET(i, &cpu_set);
    }
  } else if (cpunum == (PThreadNCPUS + 2)) {
    for (i = 0; i < PThreadNCPUS; i++) {
      CPU_SET(i, &cpu_set);
    }
  } else if (cpunum < PThreadNCPUS) {
    CPU_SET(cpunum, &cpu_set);
  }
  int res;
  if (pthread_self())
    res = pthread_setaffinity_np(pthread_self(), sizeof(cpu_set), &cpu_set);
  else {
    printf("[HOOKS] Using sched_setaffinity(gettid()) as pthread_self() == NULL\n");
    res = sched_setaffinity(syscall(SYS_gettid), sizeof(cpu_set), &cpu_set);
  }
  if (res) {
    printf("[HOOKS] pthread_setaffinity_np() for thread %u returned %d\n", threadnum, res);
  } else {
    if (DEBUG_VERBOSE)
      printf("[HOOKS] Pinning thread %u to CPU %u\n", threadnum, cpunum);
  }
}

unsigned long long rdtsc(void)
{
  unsigned long lo, hi;
  __asm__ __volatile__ (
      "rdtsc\n"
      : "=a" (lo), "=d" (hi)
      :
      : "%ebx", "%ecx" );
  return (unsigned long long)hi << 32 | lo;
} 

void parmacs_main_start() {
  PThreadId = 0;
  if (getenv("PARMACS_PINTHREADS") || PIN_THREADS)
    parmacs_pin_thread(0);

  if (DEBUG_VERBOSE)
    printf("[HOOKS] Main thread start, gettid(%lu)\n", syscall(SYS_gettid));
}

static unsigned long long time_services_begin = 0;
//static int threadJoinCount = 7;

void * parmacs_thread_start(int tid) {
  PThreadId = tid;
  if (getenv("PARMACS_PINTHREADS") || PIN_THREADS)
    parmacs_pin_thread(PThreadId);


  PThreadTable[tid].tid = gettid();

  //printf("Now process id with gettid call is %d for tid %d\n", PThreadTable[tid].tid, tid);
  
  //jbs added
  if (ENABLE_PERF_CNTRS && startThreadMonitorIndex != 0 && tid > startThreadMonitorIndex) {  
    if (tid == (startThreadMonitorIndex+1) || (tid == (startThreadMonitorIndex + 1 + numAppThreads))) {  //sunflow has 2 sets of threads each run... odd
      int i;
      printf("JBS calling perfcntr begin on VM services, pid 1 through %d \n", firstAppThreadIndex - 1);
      for (i = 1; i < firstAppThreadIndex/* PThreadIndex*/; i++) {
	thread_roi_begin(i);
	//printf("JBS calling perfcntr begin on VM services pid %d \n", i);
      }
      time_services_begin = rdtsc();
    }
    thread_roi_begin(tid);
    printf("JBS calling perfcntr begin on pid %d which is above the index %d\n", tid, startThreadMonitorIndex);

  }
  unsigned long long time_begin = rdtsc();

  if (DEBUG_VERBOSE)
    printf("[HOOKS] Thread %d start, gettid(%lu), start_routine(%lx), arg(%lx)\n",
	   PThreadId, syscall(SYS_gettid), PThreadTable[tid].func, PThreadTable[tid].arg);

  void * ret = PThreadTable[tid].func(PThreadTable[tid].arg);

  if (DEBUG_VERBOSE)
    printf("[HOOKS] Thread %d end.\n", PThreadId);
  
  //jbs added     
  if (ENABLE_PERF_CNTRS && startThreadMonitorIndex != 0 && tid > startThreadMonitorIndex) {
    //    threadJoinCount--;
    printf("JBS Actual 2.93GHz cycles spent in app thread is %lld and tid is %d and core is %d\n", (rdtsc() - time_begin ), tid, PThreadTable[tid].mappedCore);
  
    thread_roi_end(tid);
    printf("JBS calling perfcntr end on pid %d which is above the index %d\n", tid, startThreadMonitorIndex);
    if (tid == (startThreadMonitorIndex + 1) || (tid == (startThreadMonitorIndex+ 1 + numAppThreads))) { //threadJoinCount == 0) {
      if (time_services_begin != 0) {
	printf("JBS Actual 2.93GHz cycles spent in VM services threads is %lld\n", (rdtsc() - time_services_begin ));
      }

      int i;
      printf("JBS calling perfcntr end on VM services, pid 1 through %d \n", firstAppThreadIndex - 1);
      for (i = 1; i < firstAppThreadIndex; i++) {   //startThreadMonitorIndex + 1; i <= PThreadIndex; i++) {     
	thread_roi_end(i);
	//printf("JBS calling perfcntr end on VM services pid %d \n", i);
      }
    }
  }
  PThreadTable[tid].tid = 0; //no longer running

  return ret;
}

int __wrap_pthread_create(pthread_t *thread, const pthread_attr_t *attr, void *(*start_routine) (void *), void *arg)
{
  long Error, tid;

  if (PThreadIndex >= MAX_THREADS) {
    fprintf(stderr, "[HOOKS] At most %u threads supported, increase MAX_THREADS\n", MAX_THREADS);
    exit(-1);
  }
  if (DEBUG_VERBOSE)
    printf("[HOOKS] Jbsartor - In wrap_pthread_create \n");

  tid = ++PThreadIndex;
  PThreadTable[tid].func = start_routine;
  PThreadTable[tid].arg = arg;

  Error = __real_pthread_create(&PThreadTable[tid].thread, attr, (void * (*)(void *))parmacs_thread_start, (void *)tid);
  if (Error != 0) {
    printf("[HOOKS] Error in pthread_create().\n");
    exit(-1);
  }

  *thread = PThreadTable[tid].thread;
  return Error;
}

void parmacs_setup(void) __attribute ((constructor));
void parmacs_setup(void) {
  parmacs_setup_cpumap();
  parmacs_main_start();
}

void parmacs_shutdown(void) __attribute ((destructor));
void parmacs_shutdown(void) {
  if (DEBUG_VERBOSE)
    printf("[HOOKS] Main thread end.\n");
}

//jbs - new stuff from WIM below

//#define MAX_THREADS 4100

#define ARRAY_SIZE(x) (sizeof(x)/sizeof(x[0]))
#define MAX_COUNTERS                    256

#define DO_USER_SYSTEM_BREAKDOWN                    0

int nr_counters = 0;
struct perf_event_attr attrs[MAX_COUNTERS];

static int        fd[MAX_THREADS][MAX_COUNTERS];


static inline int
sys_perf_event_open(struct perf_event_attr *attr,
		    pid_t pid, int cpu, int group_fd,
		    unsigned long flags)
{
  attr->size = sizeof(*attr);
  return syscall(__NR_perf_event_open, attr, pid, cpu,
		 group_fd, flags);
}

static int hex(char ch)
{
  if ((ch >= '0') && (ch <= '9'))
    return ch - '0';
  if ((ch >= 'a') && (ch <= 'f'))
    return ch - 'a' + 10;
  if ((ch >= 'A') && (ch <= 'F'))
    return ch - 'A' + 10;
  return -1;
}

/*
 * While we find nice hex chars, build a long_val.
 * Return number of chars processed.
 */
int hex2u64(const char *ptr, __u64 *long_val)
{
  const char *p = ptr;
  *long_val = 0;

  while (*p) {
    const int hex_val = hex(*p);

    if (hex_val < 0)
      break;

    *long_val = (*long_val << 4) | hex_val;
    p++;
  }

  return p - ptr;
}


static int run_perf_stat(int tid);
static int end_perf_stat(int tid);
static void print_stat();
FILE* perfstat_file = NULL;
//static int startThreadMonitorIndex = 0;

/*HookPerfstat::*/
void HookPerfstat()
{
  const char* events = getenv("PARMACS_PERFCTRS");
  const char* filename = getenv("PARMACS_PERFCTRS_FILE");

  if (events) {
    const char* event = strtok((char *)events, ",");
    //printf("We have an event called %s\n", event); 
    nr_counters = 0;
    while(event) {
      memset(&attrs[nr_counters], 0, sizeof(attrs[nr_counters]));
      attrs[nr_counters].read_format    = PERF_FORMAT_TOTAL_TIME_ENABLED | PERF_FORMAT_TOTAL_TIME_RUNNING;
      attrs[nr_counters].inherit        = 0;
      attrs[nr_counters].disabled       = 0;
      attrs[nr_counters].enable_on_exec = 0;
      attrs[nr_counters].pinned         = 1;
      attrs[nr_counters].exclude_kernel = 1;
      attrs[nr_counters].exclude_hv     = 1;
      attrs[nr_counters].type = PERF_TYPE_RAW;
      hex2u64(event, &attrs[nr_counters].config);
      ++nr_counters;
      //      event = strtok(NULL, ",");

#ifdef DO_USER_SYSTEM_BREAKDOWN
      /*jbs duplicated from above for user/system breakdown */
      memset(&attrs[nr_counters], 0, sizeof(attrs[nr_counters]));
      attrs[nr_counters].read_format    = PERF_FORMAT_TOTAL_TIME_ENABLED | PERF_FORMAT_TOTAL_TIME_RUNNING;
      attrs[nr_counters].inherit        = 0;
      attrs[nr_counters].disabled       = 0;
      attrs[nr_counters].enable_on_exec = 0;
      attrs[nr_counters].pinned         = 1;
      attrs[nr_counters].exclude_kernel = 0;  //jbs this is now zero - different from above
      attrs[nr_counters].exclude_hv     = 1;
      attrs[nr_counters].type = PERF_TYPE_RAW;
      hex2u64(event, &attrs[nr_counters].config);
      ++nr_counters;
      //printf("JBS got to %d nr_counters\n", nr_counters);
#endif
      event = strtok(NULL, ",");

    }
    if (nr_counters > 0) {
      //printf("We have %d nr_counters\n", nr_counters);
      int m_active = 1;
      if (filename && filename[0]) {
	perfstat_file = fopen(filename, "w");
	if (!perfstat_file) {
	  fprintf(stderr, "Cannot open %s\n", filename);
	  exit(-1);
	}
      }
    }
  }
}

static unsigned long long time_begin = 0;
static int didHarnessPerfCounters = 0;

void beginAllThreadsPerfCntrs(void) 
{
  if (ENABLE_PERF_CNTRS) {  
    startThreadMonitorIndex = PThreadIndex;
    printf("JBS Starting harness with index at %d\n", startThreadMonitorIndex);
  }
  int i;
  if (ENABLE_PERF_CNTRS) {
    int i;
    if (PThreadTable[startThreadMonitorIndex - (numAppThreads - 1)].tid != 0) { //prev threads still running - perf counter them
      didHarnessPerfCounters = 1;

      printf("JBS calling perfcntr begin on VM services, pid 1 through %d \n", firstAppThreadIndex - 1);
      for (i = 1; i < firstAppThreadIndex/* PThreadIndex*/; i++) {
	thread_roi_begin(i);
	//printf("JBS calling perfcntr begin on VM services pid %d \n", i);                                                                                                 
      }
      //time_services_begin = rdtsc();
      
      for (i=(startThreadMonitorIndex - (numAppThreads - 1)); i <= startThreadMonitorIndex; i++) {
	thread_roi_begin(i);
	
	printf("JBS calling perfcntr begin on pid %d which is above the index %d\n", i, startThreadMonitorIndex - 7);
      }
      
      time_services_begin = rdtsc();
      time_begin = rdtsc();
    }
    /*for (i = 1; i < firstAppThreadIndex; i++) {  //PThreadIndex
      thread_roi_begin(i);
      printf("JBS calling perfcntr begin on pid %d \n", i);
    }
    time_begin = rdtsc();
    }*/
  }
}

void endAllThreadsPerfCntrs(void) 
{
  int i = 1;
  if (ENABLE_PERF_CNTRS) {
    /*    if (time_begin != 0) {
      printf("JBS Actual 2.93GHz cycles spent in VM services threads is %lld\n", (rdtsc() - time_begin ));
    }

    for (i = 1; i < firstAppThreadIndex; i++) {   //startThreadMonitorIndex + 1; i <= PThreadIndex; i++) {
      thread_roi_end(i);
      printf("JBS calling perfcntr end on pid %d \n", i);
      }*/
    if (didHarnessPerfCounters > 0) { //PThreadTable[startThreadMonitorIndex - 6].tid != 0) {
      if (time_begin != 0) {
	printf("JBS Actual 2.93GHz cycles spent in app thread is %lld\n", (rdtsc() - time_begin ));
      }
      if (time_services_begin != 0) {
	printf("JBS Actual 2.93GHz cycles spent in VM services threads is %lld\n", (rdtsc() - time_services_begin ));
      }
      for (i=(startThreadMonitorIndex - (numAppThreads - 1)); i <= startThreadMonitorIndex; i++) {
	thread_roi_end(i);
	printf("JBS calling perfcntr end on pid %d which is above the index %d\n", i, startThreadMonitorIndex - 7);
      }
      
      /*if (time_services_begin != 0) {
	printf("JBS Actual 2.93GHz cycles spent in VM services threads is %lld\n", (rdtsc() - time_services_begin ));
	}*/
      
      printf("JBS calling perfcntr end on VM services, pid 1 through %d \n", firstAppThreadIndex - 1);
      for (i = 1; i < firstAppThreadIndex; i++) {   //startThreadMonitorIndex + 1; i <= PThreadIndex; i++) {                                                                
	thread_roi_end(i);
	//printf("JBS calling perfcntr end on VM services pid %d \n", i);                                                                                                   
      }
      didHarnessPerfCounters = 0;
    }
    

    writePerfstat();
    startThreadMonitorIndex = 0;
  }
}

void /*HookPerfstat::*/writePerfstat(void)
{
  //print_stat();
  if (perfstat_file)
    fclose(perfstat_file);
}

void /*HookPerfstat::*/thread_roi_begin(int tid)
{
  int status = run_perf_stat(tid);
}

void /*HookPerfstat::*/thread_roi_end(int tid)
{
  end_perf_stat(tid);
}


int gettid()
{
  return syscall(__NR_gettid);
}

#define ERR_PERF_OPEN \
  "Error: counter %d, sys_perf_event_open() syscall returned with %d (%s)\n"

static void create_perf_stat_counter(int tid, int counter, int pid)
{
  //printf("JBS in create_perf, tid is %d and pid is %d\n", tid, pid);
  fd[tid][counter] = sys_perf_event_open(&attrs[counter], pid, -1, -1, 0);
  if (fd[tid][counter] < 0)
    fprintf(stderr, ERR_PERF_OPEN, counter,
	    fd[tid][counter], strerror(errno));
}

/*
 * Read out the results of a single counter:
 */
static void read_counter(int tid, int counter)
{
  uint64_t count[3];
  size_t res;

  if (fd[tid][counter] < 0)
    return;

  // printf("JBS in read counter, tid is %d, and fd is %d\n", tid, fd[tid][counter]);

  res = read(fd[tid][counter], count, 3 * sizeof(uint64_t));
  //assert(res == 3 * sizeof(uint64_t));
  if (res != 3 * sizeof(uint64_t)) {
    printf("PROBLEM, result of perf counter read is %d, which is not 3 x the size of a 64-bit int\n", res);
  }

  close(fd[tid][counter]);
  fd[tid][counter] = -1;

  if (perfstat_file)
    fprintf(perfstat_file, "%u %04llx %lld %.0f%%\n", tid, attrs[counter].config, count[0], 100. * (count[2] / (float)count[1]));
  else
    printf("[HOOKS] PERF %u %04llx %lld %.0f%%\n", tid, attrs[counter].config, count[0], 100. * (count[2] / (float)count[1]));
}

static int run_perf_stat(int tid)
{
  int counter;

  for (counter = 0; counter < nr_counters; counter++)
    create_perf_stat_counter(tid, counter, PThreadTable[tid].tid);
}

static int end_perf_stat(int tid)
{
  int counter;

  for (counter = 0; counter < nr_counters; counter++)
    read_counter(tid, counter);
}

