/*
 * Kernel module which does the frequency scaling of the cores
 *
 */

#include <linux/module.h>    
#include <linux/kernel.h>    
#include <linux/init.h>       
#include <linux/cpufreq.h>
#include <linux/cpu.h>
#include "mod_freq_scaling.h" 

/* 
 * Change the frequency of one core
 * cpuId starts from 0
 * frequency in kHz: frequency = 2000000 => 2 GHz
 */
void setFrequency(int cpuId, int frequency) {
	cpufreq_driver_target(cpufreq_cpu_get(cpuId),frequency,0);
}


/* init function of module */
static int __init mod_freq_init(void) {
	printk(KERN_INFO "Module for frequency scaling loaded!\n");  

	return 0; 
}

/* exit function of module */
static void __exit mod_freq_cleanup(void) {
	printk(KERN_INFO "Cleaning up module for frequency scaling.\n");
}


/* Expose function to other modules */
EXPORT_SYMBOL(setFrequency); 

module_init(mod_freq_init);
module_exit(mod_freq_cleanup);
MODULE_LICENSE("GPL");