#!/usr/bin/ruby

require 'pp'

unless ARGV.length == 2
	puts "Remember: ./input_plot_generator.rb <inputFile> <outputDir>"
	exit
end

input = ARGV[0]
output = ARGV[1]

inputFile = File.open(output + "/" + input,'r')
outputFile = File.open(output + "/" + input + ".formatted",'w')

title = input.gsub(".futexes","")

outputFile.puts title.gsub("_", " ")

appThreads = title.split("_")[3].gsub("app-threads","").to_i

#outputFile.puts (appThreads + 1).to_s

input_data = Array.new

inputFile.each do |line|
	split = line.split(",")
	
	input_data.push( [split[0].to_i,split[1].delete("\n").to_i] )
end

# sort input_data
input_data = input_data.sort_by{ |val| val[0] }

# first thread is not a JikesRVM thread
input_data.delete_at(0)

# find iteration number
iteration = title.split("_")[5].to_i

# find names of the threads
threadNamesFile = File.open(output + "/" + title.split("_")[0] + ".threadNames",'r')
threadNamesList = Array.new

includeName = true

threadNamesFile.each do |line|
	if not line.include? "Iteratie"
		if includeName
			threadNamesList.push(line.delete("\n"))
		else
			threadNamesList.push("DO_NOT_INCLUDE")
		end
	else 
		line.gsub!("*","")	
		currentIteration = line.split("_")[1].to_i
		
		if currentIteration == iteration
			includeName = true
		else
			includeName = false
		end
	end
end

# merge threadNames with data

i = 0
while i < threadNamesList.size and i < input_data.size
	if threadNamesList[i] != "DO_NOT_INCLUDE"
		outputFile.puts threadNamesList[i] + "," + input_data[i][1].to_s
	end
	i += 1
end

threadNamesFile.close
inputFile.close
outputFile.close

